diff --git a/src/dyna_salt.c b/src/dyna_salt.c
index 8f0c741f66..fc48687a03 100644
--- a/src/dyna_salt.c
+++ b/src/dyna_salt.c
@@ -47,7 +47,8 @@ void dyna_salt_remove_fp(void *p, char *fname, int line)
 void dyna_salt_remove_fp(void *p)
 #endif
 {
-	if (p && format && (format->params.flags & FMT_DYNA_SALT) == FMT_DYNA_SALT) {
+	if (p && (!format || /* get_salt() for dynamic format called from within valid() */
+	          (format->params.flags & FMT_DYNA_SALT) == FMT_DYNA_SALT)) {
 		dyna_salt_john_core *p1 = *((dyna_salt_john_core**)p);
 		if (p1 && p1->dyna_salt.salt_alloc_needs_free == 1) {
 #ifdef DYNA_SALT_DEBUG
